import React, { type DetailedHTMLProps, type HTMLAttributes } from 'react';
import 'jb-number-input';
import { type JBNumberInputWebComponent } from 'jb-number-input';
import { BaseProps } from 'jb-input/react';
declare global {
    namespace JSX {
        interface IntrinsicElements {
            'jb-number-input': JBNumberInputType;
        }
        interface JBNumberInputType extends DetailedHTMLProps<HTMLAttributes<JBNumberInputWebComponent>, JBNumberInputWebComponent> {
            class?: string;
            label?: string;
            name?: string;
            message?: string;
            placeholder?: string;
        }
    }
}
export declare const JBNumberInput: React.ForwardRefExoticComponent<import("jb-input/react").JBInputEvents<JBNumberInputWebComponent> & import("jb-input/react").JBInputAttributes & {
    className?: string;
    children?: React.ReactNode | React.ReactNode[];
} & {
    minValue?: number;
    maxValue?: number;
    acceptNegative?: boolean;
    decimalPrecision?: number;
    showThousandSeparator?: boolean;
    thousandSeparator?: string;
    step?: number;
    showPersianNumber?: boolean;
    showControlButton?: boolean;
} & React.RefAttributes<JBNumberInputWebComponent>>;
export type Props = BaseProps<JBNumberInputWebComponent> & {
    minValue?: number;
    maxValue?: number;
    acceptNegative?: boolean;
    decimalPrecision?: number;
    showThousandSeparator?: boolean;
    thousandSeparator?: string;
    step?: number;
    showPersianNumber?: boolean;
    showControlButton?: boolean;
};
